.CODE

DialogProc proc hWndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    Local ps:   PAINTSTRUCT
    Local pt:   POINT
    Local rct:  RECT
    Local hLib: DWORD
    Local pProc:DWORD
 
    .If uMsg == WM_INITDIALOG
    
      m2m    hWDlg,hWndDlg
      mov    inits.dwShowDetails,TRUE
      Invoke LoadLibrary,ADDR szUser32
      mov    hLib,eax
      Invoke GetProcAddress,hLib,ADDR szSLWA
      mov    pProc,eax
      
      ; set dialog transparency
      Invoke GetWindowLong,hWndDlg,GWL_EXSTYLE
      or     eax,WS_EX_LAYERED
      Invoke SetWindowLong,hWndDlg,GWL_EXSTYLE,eax
      
      push   LWA_ALPHA
      push   0
      push   NULL
      push   hWndDlg
      call   pProc     ; SetLayeredWindowAttributes
      
      Invoke FreeLibrary,hLib
      
      Invoke ShowWindow,hWndDlg,SW_SHOW
      Invoke RedrawWindow,hWndDlg,NULL,NULL,RDW_UPDATENOW
      
      push   LWA_ALPHA
      push   inits.dwTransparency
      push   NULL
      push   hWndDlg
      call   pProc     ; SetLayeredWindowAttributes 
           
      ; gfx initialisation
      Invoke ResizeDialog,hWndDlg
      Invoke InitPaint,hWndDlg
      call   Draw
      Invoke InvalidateRgn,hWndDlg,NULL,FALSE
      
      ; initialize popup menu
      Invoke LoadMenu,hInstance,ADDR szMenu
	  mov    hMenu,eax
	  Invoke GetSubMenu,hMenu,0
	  mov    hSubMenu,eax
	  mov    ecx,inits.dwTransparency
	  add    ecx,11000
      Invoke CheckMenuItem,eax,ecx,MF_CHECKED
      mov    ecx,inits.dwShowMode
      add    ecx,10002
      Invoke CheckMenuItem,hSubMenu,ecx,MF_CHECKED
      
      Invoke SetMenuItemBitmaps,hSubMenu,IDM_DET_OFF,MF_BYCOMMAND,hBmpExit,NULL
      Invoke SetMenuItemBitmaps,hSubMenu,IDM_ABOUT2,MF_BYCOMMAND,hBmpInfo,NULL
      
    .Elseif uMsg==WM_MOVING
      ; Snap window to the screen edge(s)
      ; lParam----left
      ; lParam+4--top
      ; lParam+8--right
      ; lParam+12-bottom
     
      Invoke GetCursorPos,addr ptCursor

      mov    eax,ptCursor.x
      mov    ecx,lParam
      mov    ecx,[ecx]
      add    ecx,dwCx
      sub    eax,ecx
      push   eax
      
      mov    eax,ptCursor.y
      mov    ecx,lParam
      mov    ecx,[ecx+4]
      add    ecx,dwCy
      sub    eax,ecx
      pop    ecx
      
      Invoke OffsetRect,lParam,ecx,eax
      Invoke SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR rctScr,NULL
      
      mov    inits.dwAlign,A_NONE          ; clear all position flags
      
      ; check for left docking
      mov    edx,lParam
      mov    edx,[edx]
      Invoke IsClose,edx,rctScr.left
      
      .If eax == TRUE
        mov    edx,rctScr.left
        mov    ecx,lParam
        mov    ecx,[ecx]
        sub    edx,ecx
        Invoke OffsetRect,lParam,edx,0
        add    inits.dwAlign,A_LEFT
        jmp @F
      .Endif
      
      ; check for right docking
      mov    edx,lParam
      mov    edx,[edx+8]
      Invoke IsClose,edx,rctScr.right      
      
      .If eax == TRUE
        mov    edx,rctScr.right
        mov    ecx,lParam
        mov    ecx,[ecx+8]
        sub    edx,ecx
        Invoke OffsetRect,lParam,edx,0
        add    inits.dwAlign,A_RIGHT
      .Endif      
@@:     
      ; check for top docking
      mov    edx,lParam
      mov    edx,[edx+4]
      Invoke IsClose,edx,rctScr.top      
      
      .If eax == TRUE
        mov    edx,rctScr.top
        mov    ecx,lParam
        mov    ecx,[ecx+4]
        sub    edx,ecx
        Invoke OffsetRect,lParam,0,edx
        add    inits.dwAlign,A_TOP
        jmp @F
      .Endif       

      ; check for bottom docking
      mov    edx,lParam
      mov    edx,[edx+12]
      Invoke IsClose,edx,rctScr.bottom      
      
      .If eax == TRUE
        mov    edx,rctScr.bottom
        mov    ecx,lParam
        mov    ecx,[ecx+12]
        sub    edx,ecx
        Invoke OffsetRect,lParam,0,edx
        add    inits.dwAlign,A_BOTTOM
      .Endif
@@:   jmp _out ; return TRUE
        
    .Elseif uMsg==WM_ENTERSIZEMOVE
      Invoke GetWindowRect,hWndDlg,ADDR rctDlg
      Invoke GetCursorPos,addr ptCursor
      mov    eax,ptCursor.x
      mov    edx,ptCursor.y
      sub    eax,rctDlg.left
      sub    edx,rctDlg.top
      mov    dwCx,eax
      mov    dwCy,edx
    
    .Elseif uMsg==WM_EXITSIZEMOVE
      ; store required position information for next launch
      Invoke GetWindowRect,hWndDlg,ADDR rct
      xor    eax,eax
      add    eax,inits.dwAlign
      jnz    @F
      m2m    inits.dwXPos,rct.top
      m2m    inits.dwYPos,rct.left
      jmp    done
@@:
      rcr    eax,1
      jc     rightleft
      rcr    eax,1
      jc     rightleft
      rcr    eax,1
      jc     topbottom
      rcr    eax,1
      jc     topbottom
      jmp    done
      
rightleft:
      m2m    inits.dwXPos,rct.top     ; we need top position
      mov    inits.dwYPos,0      
      jmp    done
      
topbottom:
      mov    inits.dwXPos,0
      m2m    inits.dwYPos,rct.left    ; we need left position
done:
  
    .Elseif uMsg==WM_LBUTTONDOWN
       Invoke SendMessage,hWndDlg,WM_NCLBUTTONDOWN,HTCAPTION,0
       
    .Elseif uMsg==WM_RBUTTONDOWN
      Invoke GetCursorPos,addr pt
      Invoke TrackPopupMenu,hSubMenu,TPM_RIGHTALIGN,pt.x, pt.y,NULL,hWndDlg,NULL

    .Elseif uMsg==WM_PAINT
      Invoke GetClientRect,hWndDlg,ADDR rct
      Invoke BeginPaint,hWndDlg,ADDR ps
      Invoke BitBlt,eax,0,0,rct.right,rct.bottom,hDcDB,0,0,SRCCOPY
      Invoke EndPaint,hWndDlg,ADDR ps
      
    .Elseif uMsg==WM_COMMAND
      .If lParam == 0
        mov eax,wParam
        .If ax == IDM_DET_OFF
          mov    hWDlg,0
          mov    inits.dwShowDetails,FALSE
          Invoke EnableMenuItem,hPopupMenu,IDM_DETAILS,MF_ENABLED
          Invoke EnableMenuItem,hPopupMenu,IDM_ALPHA,MF_GRAYED
          Invoke EndDialog,hWndDlg,NULL
          
        .Elseif ax==IDM_REPORTED
          Invoke CheckMenuItem,hSubMenu,IDM_REPORTED,MF_CHECKED
          Invoke CheckMenuItem,hSubMenu,IDM_DETECTED,MF_UNCHECKED
          
          mov    inits.dwShowMode,0
          call   UpdateData
          Invoke ResizeDialog,hWndDlg
          call   Draw
          
        .Elseif ax==IDM_DETECTED
          Invoke CheckMenuItem,hSubMenu,IDM_REPORTED,MF_UNCHECKED
          Invoke CheckMenuItem,hSubMenu,IDM_DETECTED,MF_CHECKED
          
          mov    inits.dwShowMode,1
          call   UpdateData
          invoke ResizeDialog,hWndDlg
          call   Draw
          
        .Elseif ax==IDM_ABOUT2
          fn MessageBoxI,hWndDlg,ADDR szMBText,ADDR szMBTitle,MB_OK,100
  
        .ElseIf ax<=IDM_00 && ax>=IDM_90
          movzx  edx,ax
          push   edx
          push   edx
          Invoke CheckMenuItem,hSubMenu,edx,MF_CHECKED
	      mov    ecx,inits.dwTransparency
	      add    ecx,11000
          Invoke CheckMenuItem,hSubMenu,ecx,MF_UNCHECKED
          pop    ecx
          sub    ecx,11000
          mov    inits.dwTransparency,ecx
          
          Invoke LoadLibrary,ADDR szUser32
          mov    hLib,eax
          Invoke GetProcAddress,hLib,ADDR szSLWA
          mov    pProc,eax          
          
          push   LWA_ALPHA
          push   inits.dwTransparency
          push   NULL
          push   hWndDlg
          call   pProc     ; SetLayeredWindowAttributes
          
          Invoke FreeLibrary,hLib
          pop    edx
          .If edx != IDM_00
            Invoke EnableMenuItem,hPopupMenu,IDM_ALPHA,MF_ENABLED
          .Endif
          
        .Elseif ax == IDM_TOPLEFT
          Invoke GetWindowRect,hWndDlg,ADDR rct
          mov eax, rct.left
          mov ecx,rct.top
          sub rct.right,eax
          sub rct.bottom,ecx
          Invoke MoveWindow,hWndDlg,0,0,rct.right,rct.bottom,TRUE
          mov    inits.dwAlign,A_LEFT_TOP
          
        .Elseif ax == IDM_TOPRIGHT
          Invoke GetWindowRect,hWndDlg,ADDR rct
          Invoke SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR rctScr,NULL
          mov eax, rct.left
          mov ecx,rct.top
          sub rct.right,eax     ; contains width
          sub rct.bottom,ecx    ; contains height
          mov eax,rct.right
          sub rctScr.right,eax
          Invoke MoveWindow,hWndDlg,rctScr.right,0,rct.right,rct.bottom,TRUE
          mov    inits.dwAlign,A_RIGHT_TOP
          
        .Elseif ax == IDM_BOTTOMLEFT
          Invoke GetWindowRect,hWndDlg,ADDR rct
          Invoke SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR rctScr,NULL
          mov eax, rct.left
          mov ecx,rct.top
          sub rct.right,eax     ; contains width
          sub rct.bottom,ecx    ; contains height
          mov eax,rct.bottom
          sub rctScr.bottom,eax
          Invoke MoveWindow,hWndDlg,0,rctScr.bottom,rct.right,rct.bottom,TRUE
          mov    inits.dwAlign,A_LEFT_BOTTOM        
        
        .Elseif ax == IDM_BOTTOMRIGHT
          Invoke GetWindowRect,hWndDlg,ADDR rct
          Invoke SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR rctScr,NULL
          mov eax, rct.left
          mov ecx,rct.top
          sub rct.right,eax     ; contains width
          sub rct.bottom,ecx    ; contains height
          mov eax,rct.bottom
          sub rctScr.bottom,eax
          mov eax,rct.right
          sub rctScr.right,eax
          Invoke MoveWindow,hWndDlg,rctScr.right,rctScr.bottom,rct.right,rct.bottom,TRUE
          mov    inits.dwAlign,A_RIGHT_BOTTOM          
        .Endif
       .Endif
    
    .Elseif uMsg==WM_CLOSE
      mov    hWDlg,0
      Invoke EnableMenuItem,hPopupMenu,IDM_DETAILS,MF_ENABLED
      Invoke EndDialog,hWndDlg,NULL
      
    .Elseif uMsg==WM_DESTROY
      Invoke DeleteObject,hBmpBck
      Invoke DeleteObject,hBmpNA
      Invoke DeleteObject,hBmpR
      Invoke DeleteObject,hBmpW
      Invoke DeleteObject,hBmpNS
      Invoke DeleteObject,hMemBmp
	    
      Invoke DeleteObject,hFont
	    
      Invoke DeleteDC,hDcFor
      Invoke DeleteDC,hDcBck
      Invoke DeleteDC,hDcDB
      Invoke DeleteDC,hDC

    .Else
        mov eax,FALSE
        ret
        
    .Endif
_out:
    mov  eax,TRUE
    ret

DialogProc endp

IsClose PROC dwA:DWORD, dwB:DWORD

	mov eax,dwA
	sub eax,dwB
	bt  eax,31
	jnc @F
	neg eax
@@:
    sub eax,16
    js @F
    mov eax,FALSE
    jmp done
@@:   
    mov eax,TRUE
done:
	Ret
	
IsClose EndP


; 

InitPaint PROC hwnd:DWORD

    Local lf:LOGFONT

	Invoke GetDC,hwnd
	mov hDC,eax

	; Create a bitmap for drawing.
	Invoke CreateCompatibleDC,hDC
	mov    hDcDB,eax
	Invoke CreateCompatibleBitmap,hDC,DB_BITMAP_WIDTH,DB_BITMAP_HEIGHT
	mov    hMemBmp,eax
	Invoke SelectObject,hDcDB,eax

	; load those small bitmaps
	Invoke LoadImage,hInstance,101,IMAGE_BITMAP,NULL,NULL,LR_DEFAULTCOLOR
	mov    hBmpBck,eax
	Invoke LoadImage,hInstance,102,IMAGE_BITMAP,NULL,NULL,LR_DEFAULTCOLOR
	mov    hBmpNA,eax
	Invoke LoadImage,hInstance,103,IMAGE_BITMAP,NULL,NULL,LR_DEFAULTCOLOR
	mov    hBmpR,eax
	Invoke LoadImage,hInstance,104,IMAGE_BITMAP,NULL,NULL,LR_DEFAULTCOLOR
	mov    hBmpW,eax
	Invoke LoadImage,hInstance,105,IMAGE_BITMAP,NULL,NULL,LR_DEFAULTCOLOR
	mov    hBmpNS,eax
	
	; create DC's for background and foreground drawing
	Invoke CreateCompatibleDC,hDC
	mov    hDcBck,eax
	Invoke CreateCompatibleDC,hDC
	mov    hDcFor,eax
	; always use the same background
	Invoke SelectObject,hDcBck,hBmpBck	
	
	; font for drive letter output
    mov    lf.lfHeight,16
    mov    lf.lfWidth,8
    mov    lf.lfEscapement,0
    mov    lf.lfOrientation,0
    mov    lf.lfWeight,FW_BOLD
    mov    lf.lfItalic,FALSE
    mov    lf.lfUnderline,FALSE
    mov    lf.lfStrikeOut,FALSE
    mov    lf.lfCharSet,DEFAULT_CHARSET
    mov    lf.lfOutPrecision,OUT_TT_ONLY_PRECIS	;OUT_DEFAULT_PRECIS
    mov    lf.lfClipPrecision,CLIP_DEFAULT_PRECIS
    mov    lf.lfQuality,PROOF_QUALITY
    mov    lf.lfPitchAndFamily,PITCH_FAMILY
    mov    lf.lfFaceName,NULL
    
    Invoke CreateFontIndirect,ADDR lf
    mov    hFont,eax
    
    ; set font drawing params
    Invoke SetBkMode,hDcDB,TRANSPARENT
	Invoke SetTextColor,hDcDB,606060h

	Ret
	
InitPaint EndP

; 

Draw PROC

    Local rct      :RECT
    Local dwTmp    :DWORD
    Local dwPtr    :DWORD
    Local hBmpTmpR :DWORD
    Local hBmpTmpW :DWORD
    ;Local hOldObj  :DWORD

    ; draw background from 1*16 pixel bitmap
    Invoke StretchBlt,hDcDB,0,0,DB_BITMAP_WIDTH,DB_BITMAP_HEIGHT,hDcBck,0,0,1,16,SRCCOPY

    mov    ecx,dwDetectedDrives
    sub    ecx,1
    
CLoop:
    push   ecx
    mov    dwTmp,ecx
    mov    edx,hGfxData
    shl    ecx,3
    add    edx,ecx
    mov    dwPtr,edx
    mov    edx,[edx]

    ; performace request not supported?
    add    edx,1
    jnz    @F
    m2m    hBmpTmpR,hBmpNS
    m2m    hBmpTmpW,hBmpNS
    jmp    Done
    
@@: ; read activity?
    sub    edx,1
    rcr    edx,1
    jnc    @F
    m2m    hBmpTmpR,hBmpR
    jmp    Wdone
@@: 
    m2m    hBmpTmpR,hBmpNA
    
Wdone:
    ; write activity?
    rcr    edx,1
    jnc    @F
    m2m    hBmpTmpW,hBmpW
    jmp    Done
@@: 
    m2m    hBmpTmpW,hBmpNA

Done:
    ; draw read and write status bitmap
    Invoke SelectObject,hDcFor,hBmpTmpR
    
    ; calculate position for drawing
    mov    ecx,dwTmp
    mov    edx,ecx
    shl    ecx,4
    shl    edx,3
    add    edx,ecx
    add    edx,15
    push   edx
    Invoke BitBlt,hDcDB,edx,1,8,7,hDcFor,0,0,SRCCOPY
    Invoke SelectObject,hDcFor,hBmpTmpW
    mov    edx,[esp]
    Invoke BitBlt,hDcDB,edx,8,8,7,hDcFor,0,0,SRCCOPY
    
    ; draw drive letter
    Invoke SelectObject,hDcDB,hFont
    
    ; calculate position for drawing
    pop    edx
    sub    edx,15
    mov    rct.left,edx
	mov    rct.top,0
	add    edx,14
	mov    rct.right,edx
	mov    rct.bottom,15
	
	; get text pointer
	mov    edx,dwPtr
	add    edx,4
    Invoke DrawText,hDcDB,edx,1,ADDR rct,DT_CENTER
    
    pop    ecx
    sub    ecx,1
    jns    CLoop
    
	Ret
Draw EndP

; 

ResizeDialog PROC hDlg:DWORD

    Local rct    :RECT

    ; ascertain position and size of dialog window
    Invoke GetWindowRect,hDlg,ADDR rct
    mov    ecx,rct.right
    sub    ecx,rct.left
    push   ecx
      
    Invoke GetClientRect,hDlg,ADDR rct
    pop    ecx
    sub    ecx,rct.right
    push   ecx
      
    Invoke SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR rct,NULL
    
    xor    eax,eax
    add    eax,inits.dwShowMode
    jz     @F   
    mov    eax,dwDetectedDrives
    jmp    done
@@:
    mov    eax,dwReportedDrives
done:    
    pop    ecx                  ; ecx = 2*borderwidth of dialog window
    mov    edx,eax
    shl    eax,4                ; eax*16
    shl    edx,3                ; edx*8
    add    eax,edx              ; dwDetectedDrives*24= ClientWidth in eax
    add    eax,ecx              ; +2*borderwidth = total width of dialog
    add    ecx,16               ; total height of dialog
    
; determine placement  
    xor    edx,edx
    add    edx,inits.dwAlign
    jnz    @F
    m2m    rct.right,inits.dwYPos
    m2m    rct.bottom,inits.dwXPos
    jmp    moveit
@@:
    .If edx==A_RIGHT_BOTTOM
      sub    rct.right,eax        ; left position of dialog
      sub    rct.bottom,ecx       ; top position of dialog
      
    .Elseif edx==A_LEFT_BOTTOM
      mov    rct.right,0
      sub    rct.bottom,ecx
      
    .elseif edx==A_LEFT_TOP
      mov    rct.right,0
      mov    rct.bottom,0
      
    .Elseif edx==A_RIGHT_TOP
      sub    rct.right,eax
      mov    rct.bottom,0
      
    .Elseif edx==A_LEFT
      mov    rct.right,0
      m2m    rct.bottom,inits.dwXPos
      
    .Elseif edx==A_RIGHT
      sub    rct.right,eax
      m2m    rct.bottom,inits.dwXPos
      
    .Elseif edx==A_TOP
      m2m    rct.right,inits.dwYPos
      mov    rct.bottom,0
      
    .Elseif edx==A_BOTTOM
      m2m    rct.right,inits.dwYPos
      sub    rct.bottom,ecx
    .Endif

moveit:

    Invoke MoveWindow,hDlg,rct.right,rct.bottom,eax,ecx,TRUE
    xor eax,eax
	Ret
	
ResizeDialog EndP

; 
