; HddMon 04/30/2006  v 0.9.0.1

; 
    Include HddMon.inc
    Include DetailsDlg.asm
; 

.code

start:

    mov    hInstance, rv(GetModuleHandle, NULL)
    mov    commandLine, rv(GetCommandLine)
    Invoke InitCommonControls
    Invoke WinMain, hInstance, NULL, commandLine, SW_SHOWDEFAULT
    Invoke ExitProcess, eax

; 

WinMain proc hInst:DWORD,hPrevInst:DWORD,cmdLine:DWORD,cmdShow:DWORD

    Local  wc     :WNDCLASSEX
    Local  msg    :MSG
    Local  osEX   :OSVINFOEX
    Local  hKey   :DWORD
    Local  dwDisp :DWORD
    Local  dwType :DWORD
    Local  dwCB   :DWORD
    Local  hLib   :DWORD
    
    ; check for SetLayeredWindowAttributes to determine
    ; we are running at least Windows 2000
    Invoke LoadLibrary,ADDR szUser32
    mov    hLib,eax
    Invoke GetProcAddress,hLib,ADDR szSLWA
    .IF eax == NULL
      fn MessageBox,0,ADDR szOsInfo,ADDR szOsInfoT, MB_OK+MB_ICONERROR
      jmp fail
    .Elseif
      Invoke FreeLibrary,hLib
    .Endif

    ; check for OS - used for icon selection
    mov    osEX.dwOSVISize,sizeof(OSVINFOEX)
    Invoke GetVersionEx,ADDR osEX
    .If osEX.dwPlatformId >= VER_PLATFORM_WIN32_NT
      .If osEX.dwMajorVersion >= 5
        .If osEX.dwMinorVersion != 0
          mov dwIsXP,TRUE   ; or later...
        .Endif
      .Endif
    .Endif

    ; restore (or create) initialisation data
    Invoke RegCreateKeyEx,HKEY_CURRENT_USER,ADDR szKey,NULL,0,0,KEY_ALL_ACCESS,NULL,ADDR hKey,ADDR dwDisp
    mov    dwCB,SIZEOF inits
    Invoke RegQueryValueEx,hKey,ADDR szVal,NULL,ADDR dwType,ADDR inits,ADDR dwCB
      .If eax != ERROR_SUCCESS
        Invoke RegSetValueEx,hKey,ADDR szVal,NULL,REG_BINARY,ADDR inits,SIZEOF inits
      .Endif
    Invoke RegCloseKey,hKey
    
    Invoke LocalAlloc,LMEM_ZEROINIT+LMEM_FIXED,SIZEOF DISK_DATA * MAX_VOLUMES
    mov    hDskData,eax
    Invoke LocalAlloc,LMEM_ZEROINIT+LMEM_FIXED,SIZEOF GFX_DETAILS * MAX_VOLUMES
    mov    hGfxData,eax
        
    mov    wc.cbSize,        sizeof WNDCLASSEX
    mov    wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov    wc.lpfnWndProc,   OFFSET WndProc
    mov    wc.cbClsExtra,    NULL
    mov    wc.cbWndExtra,    NULL
    m2m    wc.hInstance,     hInst
    mov    wc.hbrBackground, COLOR_WINDOW+1
    mov    wc.lpszMenuName,  NULL
    mov    wc.lpszClassName, OFFSET className
    mov    wc.hIcon,         NULL
    mov    wc.hCursor,       NULL
    mov    wc.hIconSm,       0
    Invoke RegisterClassEx,  ADDR wc
    Invoke CreateWindowEx,   WS_EX_OVERLAPPEDWINDOW,
                             ADDR className,
                             ADDR windowName,
                             WS_OVERLAPPEDWINDOW,
                             0,0,240,160,
                             NULL, NULL,
                             hInst, NULL
    mov    hWnd, eax

    Invoke SetTimer,hWnd,ID_TIMER,inits.dwElapse,NULL

  msgLoop:

    Invoke GetMessage,ADDR msg,NULL,0,0
    .If eax != 0
       Invoke TranslateMessage,ADDR msg
       Invoke DispatchMessage,ADDR msg
       jmp    msgLoop
    .Endif
    
    Invoke LocalFree,hGfxData
    Invoke LocalFree,hDskData
    Invoke KillTimer, hWnd,ID_TIMER

    return msg.wParam

  fail:

    return 0

WinMain endp

; 

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL pt:POINT

    .If uMsg == WM_CREATE

      invoke LoadGFX,inits.dwIconSet
      
      ; initialize popup menu
      Invoke LoadMenu,hInstance,1100
	  mov    hMainMenu,eax
	  Invoke GetSubMenu,hMainMenu,0
	  mov    hPopupMenu,eax
      
      Invoke SetMenuItemBitmaps,hPopupMenu,IDM_EXIT,MF_BYCOMMAND,hBmpExit,NULL
      Invoke SetMenuItemBitmaps,hPopupMenu,IDM_ABOUT,MF_BYCOMMAND,hBmpInfo,NULL
      Invoke SetMenuItemBitmaps,hPopupMenu,IDM_DETAILS,MF_BYCOMMAND,hBmpOpt,NULL
;      fn MessageBox,0,LastError$(),  "System Error String", MB_OK

      mov    nidWrite.cbSize,SIZEOF NOTIFYICONDATA
      m2m    nidWrite.hwnd, hWin
      mov    nidWrite.uID, IDI_TASKBARICON1
      mov    nidWrite.uFlags, NIF_ICON+NIF_MESSAGE+NIF_TIP
      mov    nidWrite.uCallbackMessage,WM_CALLBACK
      m2m    nidWrite.hIcon, hIconNA
      Invoke lstrcpy, ADDR nidWrite.szTip,ADDR windowName

      Invoke Shell_NotifyIcon,NIM_ADD,ADDR nidWrite

      mov    nidRead.cbSize,SIZEOF NOTIFYICONDATA
      m2m    nidRead.hwnd, hWin
      mov    nidRead.uID, IDI_TASKBARICON
      mov    nidRead.uFlags, NIF_ICON+NIF_MESSAGE+NIF_TIP
      mov    nidRead.uCallbackMessage,WM_CALLBACK
      m2m    nidRead.hIcon, hIconNA
      Invoke lstrcpy, ADDR nidRead.szTip,ADDR windowName

      Invoke Shell_NotifyIcon,NIM_ADD,ADDR nidRead
      
    .Elseif uMsg == WM_ENDSESSION
      call   UpdateRegistry
      
    .Elseif uMsg == WM_DESTROY
      call   UpdateRegistry
      Invoke DeleteObject,hBmpExit
      Invoke DeleteObject,hBmpInfo
      Invoke DeleteObject,hBmpOpt
      
      Invoke PostQuitMessage,NULL
      return 0
	
    .Elseif  uMsg == WM_TIMER
      call   TimerProc
      xor eax,eax
      xor ecx,ecx
      add eax,hWDlg
      jnz @F
      add ecx,inits.dwShowDetails
      jz  @F
      Invoke SendMessage,hWin,WM_COMMAND,IDM_DETAILS,0
@@:
    .Elseif  uMsg == WM_COMMAND

      .If lParam == 0
        mov eax, wParam
        .If ax == IDM_EXIT
          Invoke Shell_NotifyIcon,NIM_DELETE,ADDR nidRead
          Invoke Shell_NotifyIcon,NIM_DELETE,ADDR nidWrite
          Invoke DestroyWindow, hWin
            
        .Elseif ax == IDM_DETAILS
          .If hWDlg == FALSE
            Invoke EnableMenuItem,hPopupMenu,IDM_DETAILS,MF_GRAYED
            mov eax,inits.dwTransparency
            sub eax,255
            jns @F
            Invoke EnableMenuItem,hPopupMenu,IDM_ALPHA,MF_ENABLED
@@:
            mov    inits.dwShowDetails,TRUE
            Invoke DialogBoxParam,hInstance,101,0,ADDR DialogProc,0
          .Endif
          
        .Elseif ax == IDM_ALPHA
          Invoke SendMessage,hWDlg,WM_COMMAND,IDM_00,0
          Invoke EnableMenuItem,hPopupMenu,IDM_ALPHA,MF_GRAYED
          
        .Elseif ax == IDM_ABOUT
          fn MessageBoxI,0,ADDR szMBText,ADDR szMBTitle,MB_OK,100
        .Endif

      .Endif

    .Elseif uMsg == WM_CALLBACK

      .If wParam == IDI_TASKBARICON || wParam == IDI_TASKBARICON1
        .If lParam == WM_RBUTTONDOWN

          Invoke GetForegroundWindow
          push   eax
          Invoke SetForegroundWindow, hWin

          Invoke GetCursorPos,addr pt
          Invoke TrackPopupMenu,hPopupMenu, TPM_RIGHTALIGN,pt.x, pt.y,NULL,hWin,NULL
          pop    eax
        .Endif
      .Endif

    .Endif

    Invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret

WndProc endp

; 

LoadGFX PROC dwIconSet:DWORD

    mov    ecx,dwIsXP
    mov    eax,dwIconSet
    xor    ecx,1
    shl    eax,3
    shl    ecx,2
    
    mov    dwIconSet,eax
    add    dwIconSet,ecx
    add    dwIconSet,200
    
    mov    hIconNA,   rv(LoadImage,hInstance,dwIconSet,IMAGE_ICON,0,0,LR_DEFAULTCOLOR)
    add    dwIconSet,1
    mov    hIconRead, rv(LoadImage,hInstance,dwIconSet,IMAGE_ICON,0,0,LR_DEFAULTCOLOR)
    add    dwIconSet,1
    mov    hIconWrite,rv(LoadImage,hInstance,dwIconSet,IMAGE_ICON,0,0,LR_DEFAULTCOLOR)

    mov    hBmpExit, rv(LoadImage,hInstance,8000,IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT)
    mov    hBmpInfo, rv(LoadImage,hInstance,8001,IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT)
    mov    hBmpOpt,  rv(LoadImage,hInstance,8002,IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT)

    xor    eax,eax
	Ret
	
LoadGFX EndP

; 

MessageBoxI PROC hParent:DWORD,lpMsg:DWORD,
             lpTitle:DWORD,dlgStyle:DWORD,iconID:DWORD

    LOCAL mbp:MSGBOXPARAMS

    mov mbp.cbSize, SIZEOF MSGBOXPARAMS
    mov eax, hParent
    mov mbp.hwndOwner, eax
    mov mbp.hInstance, rv(GetModuleHandle,NULL)
    mov eax, lpMsg
    mov mbp.lpszText, eax
    mov eax, lpTitle
    mov mbp.lpszCaption, eax
    mov eax, dlgStyle
    or eax, MB_USERICON
    mov mbp.dwStyle, eax
    mov eax, iconID
    mov mbp.lpszIcon, eax
    mov mbp.dwContextHelpId, NULL
    mov mbp.lpfnMsgBoxCallback, NULL
    mov mbp.dwLanguageId, NULL

    invoke MessageBoxIndirect,ADDR mbp

    ret

MessageBoxI ENDP

; 

UpdateRegistry PROC

    Local  hKey:DWORD
    Local  dwDisp:DWORD
    Local  dwCB:DWORD
    
    Invoke RegCreateKeyEx,HKEY_CURRENT_USER,ADDR szKey,NULL,0,0,KEY_ALL_ACCESS,NULL,ADDR hKey,ADDR dwDisp
    mov    dwCB,SIZEOF inits
    Invoke RegSetValueEx,hKey,ADDR szVal,NULL,REG_BINARY,ADDR inits,SIZEOF inits
    Invoke RegCloseKey,hKey
    
	Ret
UpdateRegistry EndP

; 

TimerProc proc

Local dwIconChange:DWORD
Local dwTextChange:DWORD
Local dwChangeFlag:DWORD


    mov    dwIconChange,FALSE
    mov    dwTextChange,FALSE
	mov    dwChangeFlag,FALSE
	
    Invoke GetPhysicalDriveHandles
    ; check for devicechanges
    mov    ecx,eax
    sub    ecx,dwDriveCnt
    jz     _nochange

    push   eax
    mov    dwTextChange,TRUE
    sub    eax,1
    jnz    _more
    
    lea    edx,szOneDrive
    jmp    @F
_more:
    lea    edx,szMoreDrives
@@:
    mov    lpszFillString,edx
    pop    eax
    mov    dwDriveCnt,eax
    mov    dwDetectedDrives,eax
    
    mov    dwChangeFlag,TRUE   
    
_nochange:

    Invoke GetReadWriteActivity
    mov    dwReportedDrives,edx
    
    rcr    eax,1
    jnc    @F                      ; Read activity?
    m2m    nidRead.hIcon,hIconRead
    jmp    _write
@@:    
    m2m    nidRead.hIcon,hIconNA

_write:
    rcr    eax,1
    jnc    @F                      ; Write activity?
    m2m    nidWrite.hIcon,hIconWrite
    jmp    _cont
@@:    
    m2m    nidWrite.hIcon,hIconNA
    
_cont:
    ; check if we need to change icon(s)
    mov    eax,nidRead.hIcon
    sub    eax,hActIconR
    jz     @F
    mov    dwIconChange,TRUE
    m2m    hActIconR,nidRead.hIcon
@@:	
    mov    eax,nidWrite.hIcon
    sub    eax,hActIconW
    jz     _cleanup
    mov    dwIconChange,TRUE
    m2m    hActIconW,nidWrite.hIcon
	
_cleanup:
    Invoke ClosePhysicalDriveHandles
    
    .If dwChangeFlag==TRUE
      .If hWDlg != 0
    
;      fn MessageBox,0,ustr$(dwReportedDrives),  "ReportedDrives", MB_OK
        Invoke ResizeDialog,hWDlg
      .Endif
    .Endif

    xor    eax,eax
    add    eax,dwTextChange
    jz     _noText
    
    ; change tiptext if necessary
    mov    eax,dwReportedDrives
    sub    eax,1
    jnz    @F
    lea    edx,szOneDrive
    jmp    _more1
@@:
    lea    edx,szMoreDrives    
_more1:    
    Invoke wsprintf,ADDR nidRead.szTip,ADDR szDriveNotify,dwDriveCnt,lpszFillString,dwReportedDrives,edx
    Invoke lstrcpy, ADDR nidWrite.szTip, ADDR nidRead.szTip

_noText:
    ; change icons if necessary
    mov    eax,dwTextChange
    or     eax,dwIconChange
    jz     _done
    
	; update icons
    Invoke Shell_NotifyIcon,NIM_MODIFY,ADDR nidRead
    Invoke Shell_NotifyIcon,NIM_MODIFY,ADDR nidWrite
    
    ; update details 
    .If hWDlg != 0
      call   Draw 
      Invoke InvalidateRgn,hWDlg,NULL,FALSE
    .Endif
_done:    
    
    ret

TimerProc endp

; 
; GetPhysicalDriveHandles
; OUT: eax: Number of physical drives detected
; 

GetPhysicalDriveHandles PROC USES ebx

Local dwNumDrives:DWORD

    mov    ecx,MAX_VOLUMES-1
    mov    dwNumDrives,0
    
    mov    ebx,hDskData
    add    ebx,SIZEOF DISK_DATA * MAX_VOLUMES    
    
    ASSUME EBX:PTR DISK_DATA
@@:
	push   ecx
	sub    ebx,SIZEOF DISK_DATA
    add    cl,"a"
    mov    szVolName+4,cl             ; paste current drive letter
    mov    WORD PTR[ebx].szVolName,0  ; clear drive letter in dskdata struc
    
    Invoke CreateFile,ADDR szVolName,0,FILE_SHARE_READ or FILE_SHARE_WRITE,NULL,OPEN_EXISTING,NULL,0
    mov    [ebx].hDevice,eax
;    sub    eax,INVALID_HANDLE_VALUE
    inc    eax                        ; INVALID_HANDLE_VALUE = -1
    jz     _next
    add    dwNumDrives,1
    
    ; store drive letters only for valid volumes
    mov    cl,szVolName+4
    mov    [ebx].szVolName+1,":"     
    sub    cl,32
    mov    [ebx].szVolName,cl
_next:
    pop    ecx
    sub    ecx,1
    jns    @B
    
    ASSUME EBX:NOTHING
    mov    eax,dwNumDrives
    ret
    
GetPhysicalDriveHandles EndP

; 

ClosePhysicalDriveHandles Proc USES ebx

    mov    ecx,MAX_VOLUMES-1
    
    mov    ebx,hDskData
    add    ebx,SIZEOF DISK_DATA * MAX_VOLUMES
    
    ASSUME EBX:PTR DISK_DATA
@@:
    push   ecx
    sub    ebx,SIZEOF DISK_DATA
    .If    [ebx].hDevice != INVALID_HANDLE_VALUE
      Invoke CloseHandle, [ebx].hDevice
      mov    [ebx].hDevice,FALSE
    .Endif
    pop    ecx
    sub    ecx,1
    jns    @B
    
    ASSUME EBX:NOTHING
    ret
    
ClosePhysicalDriveHandles EndP

; 
; GetReadWriteActivity
; OUT: eax: 0 == no activity
;           1 == read activity
;           2 == write activity
;           3 == read and write activity
;      edx: number of drives that support IOCTL_DISK_PERFORMANCE request
; 

GetReadWriteActivity Proc USES ebx

Local pdf     :DISK_PERFORMANCE
Local dwCnt   :DWORD
Local dwVol   :DWORD
Local dwAct   :DWORD

    xor    eax,eax
    ASSUME EBX:PTR DISK_DATA
    mov    ecx,MAX_VOLUMES-1
    
    mov    ebx,hDskData
    add    ebx,SIZEOF DISK_DATA * MAX_VOLUMES    
    
    mov    dwAct,eax
    mov    dwVol,eax

perf:
    push   ecx
    sub    ebx,SIZEOF DISK_DATA
;    mov    [ebx].dwActivity,0
    .If [ebx].hDevice != INVALID_HANDLE_VALUE
      Invoke DeviceIoControl,[ebx].hDevice,IOCTL_DISK_PERFORMANCE,NULL,0,ADDR pdf,SizeOf pdf,ADDR dwCnt,NULL
      add    eax,eax
      jz     err
      
      add    dwVol,1
      mov    eax,pdf.ReadCount
      mov    edx,pdf.WriteCnt
      
      xor    ecx,ecx
      mov    [ebx].ActReadCnt,eax
      mov    [ebx].ActWriteCnt,edx
      
      ; Check for READ activity
      sub    eax,[ebx].OldReadCnt
      jz     @F
      or     ecx,1
@@:   
      ; Check for WRITE activity
      sub    edx,[ebx].OldWriteCnt
      jz     @F
      or     ecx,2
@@:
      mov    [ebx].dwActivity,ecx
      mov    eax,dwAct
      or     eax,ecx
      mov    dwAct,eax
      m2m    [ebx].OldWriteCnt,pdf.WriteCnt
      m2m    [ebx].OldReadCnt,pdf.ReadCount
    .Endif
    jmp    @F 
err:
    ; valid handle, but IOCTL_DISK_PERFORMANCE request is not supported (i. e. CDROM, USB Flash)
    mov    [ebx].dwActivity,-1
@@:    
    pop    ecx
    sub    ecx,1
    jns    perf
    
    call   UpdateData

    ASSUME EBX:NOTHING
    
    mov    eax,dwAct
    mov    edx,dwVol
    ret
    
GetReadWriteActivity EndP

; 

UpdateData PROC USES ebx

    ASSUME EBX:PTR DISK_DATA
    
    ; filter and sort the data for details window
    mov    ebx,hDskData
    sub    ebx,SIZEOF DISK_DATA
    mov    edx,hGfxData
    sub    edx,SIZEOF GFX_DETAILS
    xor    ecx,ecx    
@@: 
    push   ecx
    add    ebx,SIZEOF DISK_DATA 
    .If [ebx].hDevice != INVALID_HANDLE_VALUE
      ; Switch all volumes/supported volumes
      mov  eax,inits.dwShowMode
      xor  eax,[ebx].dwActivity
      add  eax,1
      jz   osd
      add  edx,SIZEOF GFX_DETAILS
      m2m  DWORD PTR [edx+4],DWORD PTR [ebx].szVolName
      m2m  DWORD PTR [edx],[ebx].dwActivity
    .Endif
osd:
    pop    ecx
    add    ecx,1
    cmp    ecx,25
    jbe     @B
    
    ASSUME EBX:NOTHING
    
	ret
UpdateData EndP

end start
