; 

    Include    \masm32\include\masm32rt.inc
    Include    \masm32\include\advapi32.inc
    Includelib \masm32\lib\advapi32.lib
    
; 

    WinMain                       PROTO :DWORD,:DWORD,:DWORD,:DWORD
    GetPhysicalDriveHandles       PROTO
    ClosePhysicalDriveHandles     PROTO
    GetReadWriteActivity          PROTO
    LoadGFX                       PROTO :DWORD
    UpdateRegistry                PROTO
    
    DialogProc                    PROTO :DWORD,:DWORD,:DWORD,:DWORD
    ResizeDialog                  PROTO :DWORD
    Draw                          PROTO
    InitPaint                     PROTO :DWORD
    
    UpdateData                    PROTO
    
    MessageBoxI                   PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    IsClose                       PROTO :DWORD,:DWORD
; 

    IOCTL_DISK_PERFORMANCE EQU 70020H
    
    IDI_TASKBARICON        EQU 0
    IDI_TASKBARICON1       EQU 1
    WM_CALLBACK            EQU WM_USER + 100
    
    ; icons menu
    IDM_MAIN               EQU 1100
    IDM_EXIT               EQU 1000
    IDM_DETAILS            EQU 1001
    IDM_ABOUT              EQU 1002
    IDM_ALPHA              EQU 1003
    
    ; details dialog menu
    IDM_ABOUT2             EQU 10001
    IDM_REPORTED           EQU 10002
    IDM_DETECTED           EQU 10003
    IDM_DET_OFF            EQU 10004
    
    ; transparency
    IDM_00                 EQU 11255
    IDM_10                 EQU 11230
    IDM_20                 EQU 11205
    IDM_30                 EQU 11179
    IDM_40                 EQU 11154
    IDM_50                 EQU 11128
    IDM_60                 EQU 11102
    IDM_70                 EQU 11077
    IDM_80                 EQU 11051
    IDM_90                 EQU 11026
    
    IDM_TOPLEFT            EQU 10005
    IDM_TOPRIGHT           EQU 10006
    IDM_BOTTOMLEFT         EQU 10007
    IDM_BOTTOMRIGHT        EQU 10008
    IDM_FIX                EQU 10009
    
    TIMER_ELAPSE           EQU 30
    ID_TIMER               EQU 1    

    MAX_VOLUMES            EQU 26
    DLG_TRANSPARENCY       EQU 179
    ID_ICON                EQU 0
    PITCH_FAMILY           EQU FF_SWISS
    
    IDD_DLG                EQU 1001
    
    WIDTH_PER_VOLUME       EQU 24
    DB_BITMAP_WIDTH        EQU MAX_VOLUMES * WIDTH_PER_VOLUME
    DB_BITMAP_HEIGHT       EQU 16
    
    A_NONE                 EQU 0000b
    A_LEFT                 EQU 0001b
    A_RIGHT                EQU 0010b
    A_TOP                  EQU 0100b
    A_BOTTOM               EQU 1000b
    A_LEFT_BOTTOM          EQU A_LEFT  + A_BOTTOM
    A_RIGHT_BOTTOM         EQU A_RIGHT + A_BOTTOM
    A_LEFT_TOP             EQU A_LEFT  + A_TOP
    A_RIGHT_TOP            EQU A_RIGHT + A_TOP

; 

DISK_PERFORMANCE STRUCT  
    BytesRead         LARGE_INTEGER <>   ; Cumulative count of bytes read from the disk since the performance counters were enabled.
    BytesWritten      LARGE_INTEGER <>   ; Cumulative count of bytes written to the disk since the performance counters were enabled.
    ReadTime          LARGE_INTEGER <>   ; Cumulative time, expressed in increments of 100 nanoseconds, spent on disk reads since the performance counters were enabled.
    WriteTime         LARGE_INTEGER <>   ; Cumulative time, expressed in increments of 100 nanoseconds, spent on disk writes since the performance counters were enabled.
    IdleTime          LARGE_INTEGER <>   ; Cumulative time, expressed in increments of 100 nanoseconds, since the performance counters were enabled in which there was no disk activity
    ReadCount         DWORD ?            ; Number of disk accesses for reads since the performance counters were enabled.
    WriteCnt          DWORD ?            ; Number of disk accesses for writes since the performance counters were enabled.
    QueueDepth        DWORD ?            ; Snapshot of the number of queued disk I/O requests at the time that the query for performance statistics was performed.
    SplitCount        DWORD ?            ; number of disk accesses by means of an associated IRP since the performance counters were enabled.
    QueryTime         LARGE_INTEGER <>   ; Timestamp indicating the system time at the moment that the query took place.
    StorageDevNumber  DWORD ?            ; Unique number assigned to every disk or volume across a particular storage type. The storage types are disk.sys, ftdisk.sys, and dmio.sys.
    StorageMngrName   WCHAR 8 DUP  (?)   ; 8-character string that indicates which device driver provided the performance statistics.
    Reserved          DWORD ?            ; 4 Fillbytes, without them DeviceIoControl function returns ERROR_INSUFFICIENT_BUFFER
DISK_PERFORMANCE ENDS

DISK_DATA STRUCT
    hDevice           DWORD ?
    ActReadCnt        DWORD ?
    ActWriteCnt       DWORD ?
    OldReadCnt        DWORD ?
    OldWriteCnt       DWORD ?
    dwActivity        DWORD ?
    szVolName         BYTE 4 DUP (?)
DISK_DATA EndS

GFX_DETAILS STRUCT
    dwVolAct          DWORD ?
    szVolName         BYTE 4 DUP (?)    
GFX_DETAILS ENDS

INIT_SETTING STRUCT
    dwElapse          DWORD ?     ; timer setting
    dwIconSet         DWORD ?     
    dwShowMode        DWORD ?     ; FALSE: reported / TRUE: detected
    dwShowDetails     DWORD ?     ; FALSE: Details initially off / TRUE: on
    dwTransparency    DWORD ?     ; Details window transparency
    dwAlign           DWORD ?     ; screen border alignment flags (A_TOP aso)
    dwXPos            DWORD ?     ; last x-position if needed
    dwYPos            DWORD ?     ; last y-position if needed
INIT_SETTING ENDS

OSVINFOEX STRUCT
    dwOSVISize        DWORD ?
    dwMajorVersion 	  DWORD ?
    dwMinorVersion    DWORD ?
    dwBuildNumber     DWORD ?
    dwPlatformId      DWORD ?
    szCSDVersion      BYTE  128  dup (?) ; Service Pack / NT family
    wSPackMajor       WORD ?
    wSPackMinor       WORD ?
    wSuiteMask 	      WORD ?
    wProductType      BYTE ?
    wReserved 	      BYTE ?
OSVINFOEX ENDS

; 

.data?
    commandLine       DWORD ?

    hInstance         DWORD ?
    hWnd              DWORD ?
    hPopupMenu        DWORD ?
    hMenu             DWORD ?
    hSubMenu          DWORD ?
    hMainMenu         DWORD ?
    hMainSubMenu      DWORD ?
    
    hIconNA           DWORD ?
    hIconRead         DWORD ?
    hIconWrite        DWORD ?
    hIconRW           DWORD ?
    hActIconR         DWORD ?
    hActIconW         DWORD ?
; popup gfx handles
    hBmpExit          DWORD ?
    hBmpInfo          DWORD ?
    hBmpOpt           DWORD ?
; details window handles
    hDC               DWORD ?
    hDcBck            DWORD ?
    hDcFor            DWORD ?
    hDcDB 	          DWORD ?
    hMemBmp           DWORD ?
; details gfx handles
    hBmpBck           DWORD ?
    hBmpNA            DWORD ?
    hBmpR             DWORD ?
    hBmpW             DWORD ?
    hBmpNS            DWORD ?
	
    hFont             DWORD ?
    
    nidRead           NOTIFYICONDATA <>
    nidWrite          NOTIFYICONDATA <>
; 

.data

    dwReads           DWORD 0
    dwWrites          DWORD 0
    dwDriveCnt        DWORD 0
    dwIsXP            DWORD 0
    dwDetectedDrives  DWORD 0
    dwReportedDrives  DWORD 0
    lpszFillString    DWORD 0

    hWDlg             DWORD 0

    hDskData          DWORD 0
    hGfxData          DWORD 0

    rctDlg            RECT <0,0,0,0>
    rctScr            RECT <0,0,0,0>
    ptCursor          POINT <0,0>
    dwCx              DWORD 0
    dwCy              DWORD 0

    inits             INIT_SETTING <TIMER_ELAPSE,ID_ICON,FALSE,FALSE,DLG_TRANSPARENCY,A_RIGHT_BOTTOM,0,0>

    szVolName         DB "\\.\ :",0
    szDriveNotify     DB " HDD Activity ",13,10," %u drive%sdetected ",13,10," %u drive%sreporting ",0
    szOneDrive        DB " ",0
    szMoreDrives      DB "s ",0
    szAlpha           DB " Reset Alpha",0
    szDetails         DB " Details",0
;    szIcon            DB "Icon.dll",0
    szKey             DB "SOFTWARE\HddMon",0
    szVal             DB "Init",0
    szMenu            DB "IDM_MNU",0
    szUser32          DB "User32.dll",0
    szSLWA            DB "SetLayeredWindowAttributes",0
    szOsInfoT         DB " Sorry, but...",0
    szOsInfo          DB "...HddMon will only work on", 13,10, " Windows 2000, Windows XP or later!",0
    className         DB "HddActivityClass",0
    windowName        DB " HDD Activity ",0
    szMBTitle         DB "About HddMon",0
    szMBText          DB " Harddisk Activity Monitor ",13,10,13,10
                      DB " Copyright  Joerg Hohaus 2006 ",13,10
                      DB "<jhohaus@web.de>",13,10,13,10
                      DB " Version: 0.9.0.2b",0
; 
